'\"
'\" Generated from file 'gpg\&.man' by tcllib/doctools with format 'nroff'
'\" Copyright (c) 2008-2016 Sergei Golovan <sgolovan@nes\&.ru>
'\"
.TH "gpg" n 1\&.0 gpg "Tcl interface to GNU Privacy Guard"
.\" The -*- nroff -*- definitions below are for supplemental macros used
.\" in Tcl/Tk manual entries.
.\"
.\" .AP type name in/out ?indent?
.\"	Start paragraph describing an argument to a library procedure.
.\"	type is type of argument (int, etc.), in/out is either "in", "out",
.\"	or "in/out" to describe whether procedure reads or modifies arg,
.\"	and indent is equivalent to second arg of .IP (shouldn't ever be
.\"	needed;  use .AS below instead)
.\"
.\" .AS ?type? ?name?
.\"	Give maximum sizes of arguments for setting tab stops.  Type and
.\"	name are examples of largest possible arguments that will be passed
.\"	to .AP later.  If args are omitted, default tab stops are used.
.\"
.\" .BS
.\"	Start box enclosure.  From here until next .BE, everything will be
.\"	enclosed in one large box.
.\"
.\" .BE
.\"	End of box enclosure.
.\"
.\" .CS
.\"	Begin code excerpt.
.\"
.\" .CE
.\"	End code excerpt.
.\"
.\" .VS ?version? ?br?
.\"	Begin vertical sidebar, for use in marking newly-changed parts
.\"	of man pages.  The first argument is ignored and used for recording
.\"	the version when the .VS was added, so that the sidebars can be
.\"	found and removed when they reach a certain age.  If another argument
.\"	is present, then a line break is forced before starting the sidebar.
.\"
.\" .VE
.\"	End of vertical sidebar.
.\"
.\" .DS
.\"	Begin an indented unfilled display.
.\"
.\" .DE
.\"	End of indented unfilled display.
.\"
.\" .SO ?manpage?
.\"	Start of list of standard options for a Tk widget. The manpage
.\"	argument defines where to look up the standard options; if
.\"	omitted, defaults to "options". The options follow on successive
.\"	lines, in three columns separated by tabs.
.\"
.\" .SE
.\"	End of list of standard options for a Tk widget.
.\"
.\" .OP cmdName dbName dbClass
.\"	Start of description of a specific option.  cmdName gives the
.\"	option's name as specified in the class command, dbName gives
.\"	the option's name in the option database, and dbClass gives
.\"	the option's class in the option database.
.\"
.\" .UL arg1 arg2
.\"	Print arg1 underlined, then print arg2 normally.
.\"
.\" .QW arg1 ?arg2?
.\"	Print arg1 in quotes, then arg2 normally (for trailing punctuation).
.\"
.\" .PQ arg1 ?arg2?
.\"	Print an open parenthesis, arg1 in quotes, then arg2 normally
.\"	(for trailing punctuation) and then a closing parenthesis.
.\"
.\"	# Set up traps and other miscellaneous stuff for Tcl/Tk man pages.
.if t .wh -1.3i ^B
.nr ^l \n(.l
.ad b
.\"	# Start an argument description
.de AP
.ie !"\\$4"" .TP \\$4
.el \{\
.   ie !"\\$2"" .TP \\n()Cu
.   el          .TP 15
.\}
.ta \\n()Au \\n()Bu
.ie !"\\$3"" \{\
\&\\$1 \\fI\\$2\\fP (\\$3)
.\".b
.\}
.el \{\
.br
.ie !"\\$2"" \{\
\&\\$1	\\fI\\$2\\fP
.\}
.el \{\
\&\\fI\\$1\\fP
.\}
.\}
..
.\"	# define tabbing values for .AP
.de AS
.nr )A 10n
.if !"\\$1"" .nr )A \\w'\\$1'u+3n
.nr )B \\n()Au+15n
.\"
.if !"\\$2"" .nr )B \\w'\\$2'u+\\n()Au+3n
.nr )C \\n()Bu+\\w'(in/out)'u+2n
..
.AS Tcl_Interp Tcl_CreateInterp in/out
.\"	# BS - start boxed text
.\"	# ^y = starting y location
.\"	# ^b = 1
.de BS
.br
.mk ^y
.nr ^b 1u
.if n .nf
.if n .ti 0
.if n \l'\\n(.lu\(ul'
.if n .fi
..
.\"	# BE - end boxed text (draw box now)
.de BE
.nf
.ti 0
.mk ^t
.ie n \l'\\n(^lu\(ul'
.el \{\
.\"	Draw four-sided box normally, but don't draw top of
.\"	box if the box started on an earlier page.
.ie !\\n(^b-1 \{\
\h'-1.5n'\L'|\\n(^yu-1v'\l'\\n(^lu+3n\(ul'\L'\\n(^tu+1v-\\n(^yu'\l'|0u-1.5n\(ul'
.\}
.el \}\
\h'-1.5n'\L'|\\n(^yu-1v'\h'\\n(^lu+3n'\L'\\n(^tu+1v-\\n(^yu'\l'|0u-1.5n\(ul'
.\}
.\}
.fi
.br
.nr ^b 0
..
.\"	# VS - start vertical sidebar
.\"	# ^Y = starting y location
.\"	# ^v = 1 (for troff;  for nroff this doesn't matter)
.de VS
.if !"\\$2"" .br
.mk ^Y
.ie n 'mc \s12\(br\s0
.el .nr ^v 1u
..
.\"	# VE - end of vertical sidebar
.de VE
.ie n 'mc
.el \{\
.ev 2
.nf
.ti 0
.mk ^t
\h'|\\n(^lu+3n'\L'|\\n(^Yu-1v\(bv'\v'\\n(^tu+1v-\\n(^Yu'\h'-|\\n(^lu+3n'
.sp -1
.fi
.ev
.\}
.nr ^v 0
..
.\"	# Special macro to handle page bottom:  finish off current
.\"	# box/sidebar if in box/sidebar mode, then invoked standard
.\"	# page bottom macro.
.de ^B
.ev 2
'ti 0
'nf
.mk ^t
.if \\n(^b \{\
.\"	Draw three-sided box if this is the box's first page,
.\"	draw two sides but no top otherwise.
.ie !\\n(^b-1 \h'-1.5n'\L'|\\n(^yu-1v'\l'\\n(^lu+3n\(ul'\L'\\n(^tu+1v-\\n(^yu'\h'|0u'\c
.el \h'-1.5n'\L'|\\n(^yu-1v'\h'\\n(^lu+3n'\L'\\n(^tu+1v-\\n(^yu'\h'|0u'\c
.\}
.if \\n(^v \{\
.nr ^x \\n(^tu+1v-\\n(^Yu
\kx\h'-\\nxu'\h'|\\n(^lu+3n'\ky\L'-\\n(^xu'\v'\\n(^xu'\h'|0u'\c
.\}
.bp
'fi
.ev
.if \\n(^b \{\
.mk ^y
.nr ^b 2
.\}
.if \\n(^v \{\
.mk ^Y
.\}
..
.\"	# DS - begin display
.de DS
.RS
.nf
.sp
..
.\"	# DE - end display
.de DE
.fi
.RE
.sp
..
.\"	# SO - start of list of standard options
.de SO
'ie '\\$1'' .ds So \\fBoptions\\fR
'el .ds So \\fB\\$1\\fR
.SH "STANDARD OPTIONS"
.LP
.nf
.ta 5.5c 11c
.ft B
..
.\"	# SE - end of list of standard options
.de SE
.fi
.ft R
.LP
See the \\*(So manual entry for details on the standard options.
..
.\"	# OP - start of full description for a single option
.de OP
.LP
.nf
.ta 4c
Command-Line Name:	\\fB\\$1\\fR
Database Name:	\\fB\\$2\\fR
Database Class:	\\fB\\$3\\fR
.fi
.IP
..
.\"	# CS - begin code excerpt
.de CS
.RS
.nf
.ta .25i .5i .75i 1i
..
.\"	# CE - end code excerpt
.de CE
.fi
.RE
..
.\"	# UL - underline word
.de UL
\\$1\l'|0\(ul'\\$2
..
.\"	# QW - apply quotation marks to word
.de QW
.ie '\\*(lq'"' ``\\$1''\\$2
.\"" fix emacs highlighting
.el \\*(lq\\$1\\*(rq\\$2
..
.\"	# PQ - apply parens and quotation marks to word
.de PQ
.ie '\\*(lq'"' (``\\$1''\\$2)\\$3
.\"" fix emacs highlighting
.el (\\*(lq\\$1\\*(rq\\$2)\\$3
..
.\"	# QR - quoted range
.de QR
.ie '\\*(lq'"' ``\\$1''\\-``\\$2''\\$3
.\"" fix emacs highlighting
.el \\*(lq\\$1\\*(rq\\-\\*(lq\\$2\\*(rq\\$3
..
.\"	# MT - "empty" string
.de MT
.QW ""
..
.BS
.SH NAME
gpg \- Tcl Interface to GnuPG
.SH SYNOPSIS
package require \fBTcl  8\&.4\fR
.sp
package require \fBTclx \fR
.sp
package require \fBgpg  1\&.0\fR
.sp
\fBset\fR \fIgpg\fR [\fB::gpg::new\fR]
.sp
\fB$gpg\fR \fIfree\fR
.sp
\fB$gpg\fR \fIset\fR \fI-property property\fR ?\fI-value value\fR?
.sp
\fB$gpg\fR \fIunset\fR \fI-property property\fR
.sp
\fB$gpg\fR \fIlist-keys\fR ?\fI-patterns patterns\fR? ?\fI-secretonly boolean\fR? ?\fI-command command\fR?
.sp
\fB$gpg\fR \fIinfo-key\fR \fI-key keytoken\fR
.sp
\fB$gpg\fR \fIencrypt\fR \fI-input input\fR ?\fI-recipients recipients\fR? ?\fI-sign boolean\fR? ?\fI-command command\fR?
.sp
\fB$gpg\fR \fIdecrypt\fR \fI-input input\fR ?\fI-checkstatus boolean\fR? ?\fI-command command\fR?
.sp
\fB$gpg\fR \fIsign\fR \fI-input input\fR ?\fI-mode mode\fR? ?\fI-command command\fR?
.sp
\fB$gpg\fR \fIverify\fR \fI-signature signature\fR ?\fI-input input\fR? ?\fI-command command\fR?
.sp
\fBset\fR \fIrecipient\fR [\fB::gpg::recipient\fR]
.sp
\fB$recipient\fR \fIadd\fR \fI-name name\fR ?\fI-validity valid\fR?
.sp
\fB$recipient\fR \fIlist\fR
.sp
.BE
.SH DESCRIPTION
.PP
This is a Tcl interface to GNU Privacy Guard with interface similar to
TclGPGME\&.
.SH COMMANDS
.TP
\fBset\fR \fIgpg\fR [\fB::gpg::new\fR]
Create a new GPG context token\&.
.TP
\fB$gpg\fR \fIfree\fR
Destroy GPG token and free its resources\&.
.TP
\fB$gpg\fR \fIset\fR \fI-property property\fR ?\fI-value value\fR?
Set or query a specified property\&.
The property argument may be one of the following:
.RS
.TP
\fBarmor\fR \fIboolean\fR
.TP
\fBtextmode\fR \fIboolean\fR
.TP
\fBpassphrase-callback\fR \fIcommand\fR
The \fBpassphrase-callback\fR property sets the command which returns the
user's GPG passphrase to the signing or encrypting/decrypting routine\&.
Note that currently GPG commonly uses \fBgpg-agent\fR to ask user for and
cache passphrases, in this case this \fBpassphrase-callback\fR property
will be ignored\&. There are two cases when it isn't:
First, \fBgpg\fR 1\&.4 (called 'classic' at the GnuPG website) without
gpg-agent enabled\&.
Second, \fBgpg\fR 2\&.1 (called 'modern' at the GnuPG website) with gpg-agent
which allows one to use loopback pinentry (essentially asking the calling
application for a passphrase) and the \fBpinentry-mode\fR property set
to \fIloopback\fR\&.
.TP
\fBpinentry-mode\fR \fImode\fR
This property makes sense only for \fBgpg\fR 2\&.1\&. See the gpg2 manual
for details\&.
.TP
\fBencoding\fR
.TP
\fBpassphrase-encoding\fR
.RE
.TP
\fB$gpg\fR \fIunset\fR \fI-property property\fR
Unset a specified property\&.
.TP
\fB$gpg\fR \fIlist-keys\fR ?\fI-patterns patterns\fR? ?\fI-secretonly boolean\fR? ?\fI-command command\fR?
Return list of key tokens which match any of a specified patterns in the
patterns list \fIpatterns\fR\&.
.TP
\fB$gpg\fR \fIinfo-key\fR \fI-key keytoken\fR
Return a serialized array of key properties\&.
.TP
\fB$gpg\fR \fIencrypt\fR \fI-input input\fR ?\fI-recipients recipients\fR? ?\fI-sign boolean\fR? ?\fI-command command\fR?
Encrypt message (using either symmetric or asymmetric algorithm)\&.
.TP
\fB$gpg\fR \fIdecrypt\fR \fI-input input\fR ?\fI-checkstatus boolean\fR? ?\fI-command command\fR?
Decrypt message\&.
.TP
\fB$gpg\fR \fIsign\fR \fI-input input\fR ?\fI-mode mode\fR? ?\fI-command command\fR?
Sign message\&.
.TP
\fB$gpg\fR \fIverify\fR \fI-signature signature\fR ?\fI-input input\fR? ?\fI-command command\fR?
Verify signature\&.
.TP
\fBset\fR \fIrecipient\fR [\fB::gpg::recipient\fR]
Create recipients token\&.
.TP
\fB$recipient\fR \fIadd\fR \fI-name name\fR ?\fI-validity valid\fR?
Add name to a recipient token\&.
.TP
\fB$recipient\fR \fIlist\fR
Return a list of recipients in a recipient token\&.
.PP
.SH "ASYNCHRONOUS MODE"
Many GPG subcommands may posess \fI-command\fR options\&. It turns
asynchronous mode on and specifies a callback which is called to return
operation result\&. This means that the command returns immediately, the pipe
to GPG is switched to non-blocking mode and data from it is read only when
it is available\&. After the operation is completed the callback is invoked
with appended status (\\"ok\\" or \\"error\\") and the operation result in the
same form as it would be returned in synchronous mode\&.
.SH EXAMPLES
Encrypt the word Hello using a symmetric encryption using
passphrase "abcdefgh":
.CS


proc pass {args} {return abcdefgh}
set gpg [::gpg::new]
$gpg set -property armor -value true
$gpg set -property encoding -value utf-8
$gpg set -property passphrase-callback -value pass
puts [$gpg encrypt -input Hello]
$gpg free

.CE
.SH ENVIRONMENT
.TP
\fB$GPG_EXECUTABLE\fR
This variable specifies the GnuPG executable if it isn't \fBgpg\fR or
can't be found in a directory from the \fB$PATH\fR environment variable\&.
.TP
\fB$GPG_AGENT_INFO\fR
This variable is required for the \fBgpg\fR packge to work with GnuPG 2\&.0\&.
.PP
.SH "SEE ALSO"
https://www\&.gnupg\&.org
.SH AUTHORS
Sergei Golovan
.SH KEYWORDS
GnuPG, Tcl
.SH COPYRIGHT
.nf
Copyright (c) 2008-2016 Sergei Golovan <sgolovan@nes\&.ru>

.fi
